apiVersion: tekton.dev/v1beta1
kind: Pipeline
metadata:
  labels:
    scan-code: "{{ scan_code_with }}"
    scan-image: "{{ scan_images_with }}"
    scan-repo: "{{ scan_repos_with }}"
    sign-image: "{{ sign_images_with }}"
    version: "{{ tekton_assets_version }}"
  name: {{ templatename | default('sync-to-gitlab') }}
  namespace: {{ buildns }}
spec:
  params:
  - name: dstimage
    description: Destination image URL
    type: string
  - default: nonexistant
    description: Optional Target Registry Secret
    name: dstsecret
    type: string
  - name: srcimage
    description: Source image URL
    type: string
  - default: nonexistant
    description: Optional Source Registry Secret
    name: srcsecret
    type: string
  tasks:
  - name: build
    params:
    - name: dstimage
      value: "$(params.dstimage)"
    - name: dstsecret
      value: "$(params.dstsecret)"
    - name: srcimage
      value: "$(params.srcimage)"
    - name: srcsecret
      value: "${params.srcsecret)"
    taskRef:
      name: sync-image
{% if tekton_sign_images and (found_cosign_secret | default(False) or found_gpg_secret | default(False)) %}
  - name: sign-image
    params:
    - name: dstimage
      value: "$(params.dstimage)"
    - name: IMAGE_DIGEST
      value: "$(tasks.build.results.IMAGE_DIGEST)"
    retries: 2
    runAfter:
    - build
    taskRef:
{% if found_cosign_secret | default(False) %}
      name: sign-image-cosign
{% else %}
      name: sign-image-gpg
{% endif %}
    when:
    - input: "$(workspaces.sigsecret.bound)"
      operator: in
      values: ["true"]
    workspaces:
    - name: sigsecret
      workspace: sigsecret
{% endif %}
  workspaces:
  - name: sigsecret
    optional: true
